{{output.spin
  toggle pin}}

CON

  _CLKMODE = XTAL1 + PLL8X
  _XINFREQ = 10_000_000

Var
  long Stack[9]    'stack space for new cog
  byte Cog           'hold id of cog in use, if any

pub start(pin, delay, count): Success
{{start new toggling processs in a new cog; return TRUE if successful}}

  stop
  Success := (cog:= cognew(toggle(pin, delay, count), @stack) + 1)

pub stop
{{stop toggling process, if any}}

  if Cog
    cogstop(cog~ - 1)

pub active:YesNo
{{return TRUE if process is active, FALSE otherwise}}

  YesNo := cog > 0    

pub toggle(pin, delay, count)
{{toggle pin, count times with delayMS milliseconds in between
  if count = 0, toggle pin forever}}
  dira[pin]~~                'set i/o pin to output direction
  repeat                      'repeat the following
    !outa[pin]                      'toggle i/o pin
    waitcnt(delay + cnt)           'wait for delay cycles
  while count := --count #> -1    'while count not 0 (make min -1)
  cog~                                   'clear cog id var